DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Server-Side Data Processing

In many cases, you need to process data on the server before a chart displays it. The Chart component supports this scenario.

In this demo, the data source of the Chart loads weather data for a selected month from an OData service. Each time you select a different month in the drop-down menu, the data source sends a new query to the service. To implement this functionality, assign a DataSource object to the Chart's dataSource property.

In the DataSource, implement the ODataStore. An OData service can include multiple entity collections related to each other, but the ODataStore specifies only one collection. To load multiple collections at once, set the expand property to an array with the additional collection titles. Then, call the postProcess function to process additional data.

Set the paginate property to false to prevent data from partitioning. You can also apply a filter to the received values.

Once you load the data, specify the series type and its nested options (argumentField and valueField), so the component can determine the objects that indicate Chart arguments and values in the data source.

A 1-Click Solution for CRUD Web API Services with Role-based Access Control via EF Core

If you target .NET for your backend API, be sure to check out Web API Service and register your free copy today. The Solution Wizard scaffolds an OData v4 Web API Service (.NET 6+) with integrated authorization & CRUD operations powered by EF Core ORM. You can use OAuth2, JWT or custom authentication strategies alongside tools like Postman or Swagger (OpenAPI) for API testing. The built-in Web API Service also filters out secured server data based on permissions granted to users. Advanced/enterprise functions include audit trail, endpoints to download reports, file attachments, check validation, obtain localized captions, etc.

To use the free Solution Wizard (which creates the Web API Service), run the Universal Component Installer from the DevExpress Download Manager and use our predefined template in Visual Studio 2022+.

Read Tutorial | View Examples: JavaScript (DevExtreme) & JavaScript (Svelte) | Watch Videos

www.wikipedia.org
Backend API
$(() => { const chartDataSource = new DevExpress.data.DataSource({ store: { type: 'odata', version: 2, url: 'https://js.devexpress.com/Demos/WidgetsGallery/odata/WeatherItems', }, postProcess(results) { return results[0].DayItems; }, expand: 'DayItems', filter: ['Id', '=', 1], paginate: false, }); const chartOptions = { dataSource: chartDataSource, title: 'Temperature in Seattle , 2017', size: { height: 420, }, series: { argumentField: 'Number', valueField: 'Temperature', type: 'spline', }, legend: { visible: false, }, commonPaneSettings: { border: { visible: true, width: 2, top: false, right: false, }, }, export: { enabled: true, }, tooltip: { enabled: true, customizeTooltip(arg) { return { text: `${arg.valueText}&#176C`, }; }, }, valueAxis: { valueType: 'numeric', grid: { opacity: 0.2, }, label: { customizeText() { return `${this.valueText}&#176C`; }, }, }, argumentAxis: { type: 'discrete', grid: { visible: true, opacity: 0.5, }, }, loadingIndicator: { enabled: true, }, }; $('#chart').dxChart(chartOptions); $('#selectbox').dxSelectBox({ width: 150, items: months, value: 1, inputAttr: { 'aria-label': 'Month' }, valueExpr: 'id', displayExpr: 'name', onValueChanged(data) { chartDataSource.filter(['Id', '=', data.value]); chartDataSource.load(); }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.6/css/dx.light.css" /> <script src="js/dx.all.js"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="chart-demo"> <div id="chart"></div> <div class="action"> <div class="label">Choose a month:</div> <div id="selectbox"></div> </div> </div> </div> </body> </html>
.action { width: 270px; margin-top: 20px; display: flex; justify-content: space-between; align-items: center; }
const months = [{ id: 1, name: 'January', }, { id: 2, name: 'February', }, { id: 3, name: 'March', }, { id: 4, name: 'April', }, { id: 5, name: 'May', }, { id: 6, name: 'June', }, { id: 7, name: 'July', }, { id: 8, name: 'August', }, { id: 9, name: 'September', }, { id: 10, name: 'October', }, { id: 11, name: 'November', }, { id: 12, name: 'December', }];

<div id="chart-demo">
<dx-chart
[dataSource]="chartDataSource"
title="Temperature in Seattle , 2017"
[valueAxis]="{
valueType: 'numeric',
grid: {
opacity: 0.2
},
label: {
customizeText: customizeText
}
}"
>
<dxo-size [height]="420"></dxo-size>
<dxi-series
argumentField="Number"
valueField="Temperature"
type="spline"
></dxi-series>
<dxo-legend [visible]="false"></dxo-legend>
<dxo-common-pane-settings>
<dxo-border
[visible]="true"
[width]="2"
[top]="false"
[right]="false"
></dxo-border>
</dxo-common-pane-settings>
<dxo-export [enabled]="true"></dxo-export>
<dxo-tooltip
[enabled]="true"
[customizeTooltip]="customizeTooltip"
></dxo-tooltip>
<dxo-argument-axis type="discrete">
<dxo-grid [visible]="true" [opacity]="0.5"></dxo-grid>
</dxo-argument-axis>
<dxo-loading-indicator [enabled]="true"></dxo-loading-indicator>
</dx-chart>
<div class="action">
<div class="label">Choose a month:</div>
<dx-select-box
id="selectbox"
[items]="months"
[width]="150"
[inputAttr]="{ 'aria-label': 'Month' }"
[value]="1"
valueExpr="id"
displayExpr="name"
(onValueChanged)="onValueChanged($event)"
></dx-select-box>
</div>
</div>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxChartModule, DxSelectBoxModule } from 'devextreme-angular';
import DataSource from 'devextreme/data/data_source';
import 'devextreme/data/odata/store';
import { Month, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
})
export class AppComponent {
months: Month[];
chartDataSource: DataSource;
constructor(service: Service) {
this.months = service.getMonths();
this.chartDataSource = new DataSource({
store: {
type: 'odata',
version: 2,
url: 'https://js.devexpress.com/Demos/WidgetsGallery/odata/WeatherItems',
},
postProcess: (results) => results[0].DayItems,
expand: 'DayItems',
filter: ['Id', '=', 1],
paginate: false,
});
}
customizeTooltip(arg) {
return {
text: `${arg.valueText}°C`,
};
}
customizeText(arg) {
return `${arg.valueText}°C`;
}
onValueChanged(data) {
this.chartDataSource.filter(['Id', '=', data.value]);
this.chartDataSource.load();
}
}
@NgModule({
imports: [
BrowserModule,
DxChartModule,
DxSelectBoxModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .action {
width: 270px;
margin-top: 20px;
display: flex;
justify-content: space-between;
align-items: center;
}
import { Injectable } from '@angular/core';
export class Month {
id: number;
name: string;
}
const months: Month[] = [{
id: 1,
name: 'January',
}, {
id: 2,
name: 'February',
}, {
id: 3,
name: 'March',
}, {
id: 4,
name: 'April',
}, {
id: 5,
name: 'May',
}, {
id: 6,
name: 'June',
}, {
id: 7,
name: 'July',
}, {
id: 8,
name: 'August',
}, {
id: 9,
name: 'September',
}, {
id: 10,
name: 'October',
}, {
id: 11,
name: 'November',
}, {
id: 12,
name: 'December',
}];
@Injectable()
export class Service {
getMonths(): Month[] {
return months;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speed-dial-action',
'splitter',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@24.2.7/cjs',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'devextreme/bundles/dx.all': 'npm:devextreme@24.2.7/bundles/dx.all.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.16',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.60',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.16/package.json',
'npm:devexpress-gantt@4.1.60/package.json',
],
};
System.config(window.config);
// System.import('@angular/compiler').catch(console.error.bind(console));
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.2.7/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.14.10/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

import React from 'react';
import DataSource from 'devextreme/data/data_source';
import 'devextreme/data/odata/store';
import Chart, {
ValueAxis,
ArgumentAxis,
CommonPaneSettings,
Grid,
Series,
Label,
Legend,
Size,
Border,
Tooltip,
Export,
LoadingIndicator,
} from 'devextreme-react/chart';
import SelectBox from 'devextreme-react/select-box';
import { months, monthLabel } from './data.js';
class App extends React.Component {
constructor(props) {
super(props);
this.chartDataSource = new DataSource({
store: {
type: 'odata',
url: 'https://js.devexpress.com/Demos/WidgetsGallery/odata/WeatherItems',
},
postProcess(results) {
return results[0].DayItems;
},
expand: 'DayItems',
filter: ['Id', '=', 1],
paginate: false,
});
this.onValueChanged = (data) => {
this.chartDataSource.filter(['Id', '=', data.value]);
this.chartDataSource.load();
};
}
render() {
return (
<div id="chart-demo">
<Chart
title="Temperature in Seattle , 2017"
dataSource={this.chartDataSource}>
<Size height={420} />
<ValueAxis
valueType="numeric"
>
<Grid opacity={0.2} />
<Label customizeText={this.customizeLabel} />
</ValueAxis>
<ArgumentAxis type="discrete">
<Grid visible={true} opacity={0.5} />
</ArgumentAxis>
<CommonPaneSettings>
<Border
visible={true}
width={2}
top={false}
right={false}
/>
</CommonPaneSettings>
<Series
argumentField="Number"
valueField="Temperature"
type="spline"
/>
<Legend visible={false} />
<Export enabled={true} />
<Tooltip
enabled={true}
customizeTooltip={customizeTooltip} />
<LoadingIndicator enabled={true} />
</Chart>
<div className="action">
<div className="label">Choose a month:
</div>
<SelectBox
id="selectbox"
width={150}
valueExpr="id"
inputAttr={monthLabel}
displayExpr="name"
items={months}
defaultValue={1}
onValueChanged={this.onValueChanged} />
</div>
</div>
);
}
customizeLabel(e) {
return `${e.valueText}${'°C'}`;
}
}
function customizeTooltip(arg) {
return {
text: `${arg.valueText}${'°C'}`,
};
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.action {
width: 270px;
margin-top: 20px;
display: flex;
justify-content: space-between;
align-items: center;
}
export const months = [{
id: 1,
name: 'January',
}, {
id: 2,
name: 'February',
}, {
id: 3,
name: 'March',
}, {
id: 4,
name: 'April',
}, {
id: 5,
name: 'May',
}, {
id: 6,
name: 'June',
}, {
id: 7,
name: 'July',
}, {
id: 8,
name: 'August',
}, {
id: 9,
name: 'September',
}, {
id: 10,
name: 'October',
}, {
id: 11,
name: 'November',
}, {
id: 12,
name: 'December',
}];
export const monthLabel = { 'aria-label': 'Month' };
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.6/cjs',
'devextreme-react': 'npm:devextreme-react@23.1.6',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.2/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.49/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

<template>
<div id="chart-demo">
<DxChart
:data-source="chartDataSource"
:title="`Temperature in Seattle, ${year}`"
>
<DxSize :height="420"/>
<DxValueAxis
:grid="{ opacity: 0.2 }"
value-type="numeric"
>
<DxLabel :customize-text="customizeLabelText"/>
</DxValueAxis>
<DxArgumentAxis type="discrete">
<DxGrid
:visible="true"
:opacity="0.5"
/>
<DxLabel :customize-text="customizeArgumentAxisLabelText"/>
</DxArgumentAxis>
<DxCommonPaneSettings>
<DxBorder
:visible="true"
:width="2"
:top="false"
:right="false"
/>
</DxCommonPaneSettings>
<DxSeries
argument-field="Date"
value-field="Temperature"
type="spline"
/>
<DxLegend :visible="false"/>
<DxTooltip
:enabled="true"
:customize-tooltip="customizeTooltip"
/>
<DxExport :enabled="true"/>
<DxLoadingIndicator :enabled="true"/>
</DxChart>
<div class="action">
<div class="label">Choose a month:</div>
<DxSelectBox
id="selectbox"
:width="150"
:items="months"
:input-attr="{ 'aria-label': 'Month' }"
:value="selectedMonth"
:on-value-changed="onValueChanged"
value-expr="id"
display-expr="name"
/>
</div>
</div>
</template>
<script setup lang="ts">
import DxChart, {
DxValueAxis,
DxArgumentAxis,
DxCommonPaneSettings,
DxGrid,
DxSeries,
DxLegend,
DxSize,
DxBorder,
DxLabel,
DxTooltip,
DxExport,
DxLoadingIndicator,
} from 'devextreme-vue/chart';
import DxSelectBox, { type DxSelectBoxTypes } from 'devextreme-vue/select-box';
import { DataSource } from 'devextreme-vue/common/data';
import { months } from './data.ts';
const year = 2017;
let selectedMonth = 1;
const startOfMonthStr = (month: number): string => `${month}/01/${year}`;
const endOfMonthStr = (month: number): string => {
const nextMonth = (month === 12) ? 1 : month + 1;
const nextYear = (month === 12) ? year + 1 : year;
const lastDay = new Date(nextYear, nextMonth - 1, 0).getDate();
return `${month}/${lastDay}/${year}`;
};
const chartDataSource = new DataSource({
key: 'Date',
load: () => {
const startVisible = startOfMonthStr(selectedMonth);
const endVisible = endOfMonthStr(selectedMonth);
const url = 'https://js.devexpress.com/Demos/NetCore/api/TemperatureData'
+ `?startVisible=${encodeURIComponent(startVisible)}`
+ `&endVisible=${encodeURIComponent(endVisible)}`
+ `&startBound=${encodeURIComponent(startVisible)}`
+ `&endBound=${encodeURIComponent(endVisible)}`;
return fetch(url)
.then((r) => {
if (!r.ok) throw new Error(`Network response fails: ${r.status}`);
return r.json();
})
.then((arr) => arr.map((item: Record<string, any>) => ({
...item,
Temperature: (item.MinTemp + item.MaxTemp) / 2,
Date: new Date(item.Date),
})));
},
paginate: false,
});
const customizeLabelText = ({ valueText }: any) => `${valueText}${'°C'}`;
const customizeArgumentAxisLabelText = ({ value }: any) => new Date(value).getDate().toString();
const customizeTooltip = ({ valueText }: any) => ({
text: `${valueText}${'°C'}`,
});
function onValueChanged({ value }: DxSelectBoxTypes.ValueChangedEvent) {
selectedMonth = value;
chartDataSource.load();
}
</script>
<style>
.action {
width: 270px;
margin-top: 20px;
display: flex;
justify-content: space-between;
align-items: center;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@5.0.0/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
export const months = [{
id: 1,
name: 'January',
}, {
id: 2,
name: 'February',
}, {
id: 3,
name: 'March',
}, {
id: 4,
name: 'April',
}, {
id: 5,
name: 'May',
}, {
id: 6,
name: 'June',
}, {
id: 7,
name: 'July',
}, {
id: 8,
name: 'August',
}, {
id: 9,
name: 'September',
}, {
id: 10,
name: 'October',
}, {
id: 11,
name: 'November',
}, {
id: 12,
name: 'December',
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.4.5/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>